/*
Scribble - touch-to-mouse.js
Copyright (c) 2012 Greg Sydney-Smith

This file is part of Scribble.

Scribble is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later version.

Scribble is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with Scribble.  If not, see <http://www.gnu.org/licenses/>.

Revision History:
2012-12-27 Initial Release.
*/

function touchHandler(event)
{
    var touches = event.changedTouches,
        first = touches[0],
        type = "";

    switch (event.type) {
        case "touchstart": type= "mousedown"; break;
        case "touchmove" : type= "mousemove"; break;        
        case "touchend"  : type= "mouseup";   break;
        default          : return;
    }

    //initMouseEvent(type, canBubble, cancelable, view, clickCount, 
    //           screenX, screenY, clientX, clientY, ctrlKey, 
    //           altKey, shiftKey, metaKey, button, relatedTarget);

    var simulatedEvent = document.createEvent("MouseEvent");
    simulatedEvent.initMouseEvent(type, true, true, window, 1, 
                              first.screenX, first.screenY, 
                              first.clientX, first.clientY, false, 
                              false, false, false, 0/*left*/, null);
    first.target.dispatchEvent(simulatedEvent);
    event.preventDefault();
}

// use allowTouchDragAndDrop(document) for all
// but note it stops click events so it is better to only use it where needed
function allowTouchDragAndDrop(el) {
    el.addEventListener("touchstart" , touchHandler, true);
    el.addEventListener("touchmove"  , touchHandler, true);
    el.addEventListener("touchend"   , touchHandler, true);
    el.addEventListener("touchcancel", touchHandler, true);    
}
